# coding: utf-8

"""
    Fingerprint Server API

    Fingerprint Server API allows you to search, update, and delete identification events in a server environment. It can be used for data exports, decision-making, and data analysis scenarios. Server API is intended for server-side usage, it's not intended to be used from the client side, whether it's a browser or a mobile device.   # noqa: E501

    OpenAPI spec version: 3
    Contact: support@fingerprint.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import Dict, List, Optional  # noqa: F401
from fingerprint_pro_server_api_sdk.base_model import BaseModel
from fingerprint_pro_server_api_sdk.models.proxy_confidence import ProxyConfidence


class WebhookProxy(BaseModel):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'result': 'bool',
        'confidence': 'ProxyConfidence'
    }

    nullable_map = {
        'result': False,
        'confidence': False
    }

    attribute_map = {
        'result': 'result',
        'confidence': 'confidence'
    }

    def __init__(self, result=None, confidence=None):  # noqa: E501
        """WebhookProxy - a model defined in Swagger"""  # noqa: E501
        self._result = None
        self._confidence = None
        self.discriminator = None
        if result is not None:
            self.result = result
        if confidence is not None:
            self.confidence = confidence

    @property
    def result(self) -> Optional[bool]:
        """Gets the result of this WebhookProxy.  # noqa: E501

        IP address was used by a public proxy provider or belonged to a known recent residential proxy   # noqa: E501

        :return: The result of this WebhookProxy.  # noqa: E501
        """
        return self._result

    @result.setter
    def result(self, result: Optional[bool]):
        """Sets the result of this WebhookProxy.

        IP address was used by a public proxy provider or belonged to a known recent residential proxy   # noqa: E501

        :param result: The result of this WebhookProxy.  # noqa: E501
        """

        self._result = result

    @property
    def confidence(self) -> Optional[ProxyConfidence]:
        """Gets the confidence of this WebhookProxy.  # noqa: E501


        :return: The confidence of this WebhookProxy.  # noqa: E501
        """
        return self._confidence

    @confidence.setter
    def confidence(self, confidence: Optional[ProxyConfidence]):
        """Sets the confidence of this WebhookProxy.


        :param confidence: The confidence of this WebhookProxy.  # noqa: E501
        """

        self._confidence = confidence

